#ifndef DEQUE_HPP
#define DEQUE_HPP

#include <array>
#include <iostream>
#include <optional>
#include <utility>

using namespace std;

template<typename T>
class Deque {
    struct Chunk {
        int         used = 0;
        array<T, 3> elements {};
        Chunk*      next = nullptr;
        Chunk*      prev = nullptr;
    };
    Chunk* start = nullptr;
    Chunk* end   = nullptr;
    size_t size  = 0;

    public:
    Deque() = default;

    /*
        these two lines make sure that our deque is never copied.
        just ignore or look up "copy constructor" and "copy assignment operator".
    */
    Deque(const Deque&)            = delete;
    Deque& operator=(const Deque&) = delete;

    inline size_t get_size() const { return size; }

    // a) print
    void print() const { /* CODE HERE */
    }

    void printReversed() const { /* CODE HERE */
    }

    // b) enqueue
    void enqueueBack(T value) { /* CODE HERE */
    }

    void enqueueFront(T value) { /* CODE HERE */
    }

    // c) dequeue
    optional<T> dequeueBack() {
        /* REPLACE WITH IMPLEMENTAION */
        return T {};
    }

    optional<T> dequeueFront() {
        /* REPLACE WITH IMPLEMENTAION */
        return T {};
    }

    // d) dtor
    ~Deque() { /* CODE HERE */
    }

    // e) removeAt
    optional<pair<Chunk*, size_t>> findChunkForIndex(size_t index) const {
        /* REPLACE WITH IMPLEMENTAION */
        return T {};
    }

    optional<T> removeAt(size_t index) {
        /* REPLACE WITH IMPLEMENTAION */
        return T {};
    }

    // f) insertAt
    bool insertAt(size_t index, T value) {
        /* REPLACE WITH IMPLEMENTAION */
        return false;
    }
};

#endif
